﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Web.Script.Serialization;

namespace TrackService.Samples.Json.Dispatch
{
    class Program
    {
        static string loginUrl = "http://trackservice.trackroad.com/rest/login";
        static string dispatchUrl = "http://trackservice.trackroad.com/rest/dispatch";

        static string userName = "your_user_name";
        static string password = "your_password";

        static string latLonRequest = "{\"RoutingService\":0,\"IsNeedMatchCode\":false,\"CurrentTime\":\"0001-01-01T00:00:00Z\",\"DispatchMode\":0,\"MinimumOptimization\":1,\"DistanceUnit\":0,\"Vehicles\":[{\"Name\":\"V1\",\"Email\":null,\"Group\":null,\"Speed\":0,\"MaxStops\":0,\"MaxWeight\":0,\"MaxSkids\":0,\"MaxVolume\":0,\"MaxMinutes\":0,\"OnTheRoad\":false,\"Tin\":\"0001-01-01T00:00:00Z\",\"Tout\":\"0001-01-01T00:00:00Z\",\"StartLocation\":{\"MatchCode\":0,\"Name\":null,\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":27.9642601,\"Longitude\":-82.494751},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},\"FinishLocation\":null}],\"Locations\":[{\"MatchCode\":0,\"Name\":\"Brussel\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":28.0548688,\"Longitude\":-82.4993688},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0}]}";
        static string addressRequest = "{\"RoutingService\":0,\"IsNeedMatchCode\":true,\"CurrentTime\":\"0001-01-01T00:00:00Z\",\"DispatchMode\":0,\"MinimumOptimization\":4,\"DistanceUnit\":0,\"Vehicles\":[{\"Name\":\"V1\",\"Email\":null,\"Group\":null,\"Speed\":0,\"MaxStops\":0,\"MaxWeight\":0,\"MaxSkids\":0,\"MaxVolume\":0,\"MaxMinutes\":0,\"OnTheRoad\":false,\"Tin\":\"0001-01-01T00:00:00Z\",\"Tout\":\"0001-01-01T00:00:00Z\",\"StartLocation\":{\"MatchCode\":0,\"Name\":null,\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":null,\"Address\":{\"Street\":\"6718 Whittier Avenue\",\"City\":\"McLean\",\"State\":\"VA\",\"PostalCode\":\"22101\",\"Country\":null},\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},\"FinishLocation\":{\"MatchCode\":0,\"Name\":null,\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":null,\"Address\":{\"Street\":\"1309 Vincent Place\",\"City\":\"McLean\",\"State\":\"VA\",\"PostalCode\":\"22101\",\"Country\":null},\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0}}],\"Locations\":[{\"MatchCode\":0,\"Name\":\"Stop A\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":null,\"Address\":{\"Street\":\"1450 Chain Bridge Road\",\"City\":\"McLean\",\"State\":null,\"PostalCode\":\"22101\",\"Country\":null},\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"Stop B\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":null,\"Address\":{\"Street\":\"1309 Vincent Place\",\"City\":\"McLean\",\"State\":null,\"PostalCode\":\"22101\",\"Country\":null},\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0}]}";
        static string midwayRequest = "{\"RoutingService\":0,\"IsNeedMatchCode\":false,\"CurrentTime\":\"0001-01-01T00:00:00Z\",\"DispatchMode\":0,\"MinimumOptimization\":1,\"DistanceUnit\":0,\"Vehicles\":[{\"Name\":\"V1\",\"Email\":null,\"Group\":null,\"Speed\":100,\"MaxStops\":0,\"MaxWeight\":180,\"MaxSkids\":0,\"MaxVolume\":0,\"MaxMinutes\":0,\"OnTheRoad\":false,\"Tin\":\"0001-01-01T00:00:00Z\",\"Tout\":\"0001-01-01T00:00:00Z\",\"StartLocation\":{\"MatchCode\":0,\"Name\":null,\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.190377,\"Longitude\":-73.372059},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},\"FinishLocation\":{\"MatchCode\":0,\"Name\":null,\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.190377,\"Longitude\":-73.372059},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0}}],\"Locations\":[{\"MatchCode\":0,\"Name\":\"Drop01\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.190377,\"Longitude\":-73.372059},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":4,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"0001\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.189149,\"Longitude\":-73.365788},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":50,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"0002\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.170298,\"Longitude\":-73.380508},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":50,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"0003\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.180726,\"Longitude\":-73.365836},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":50,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"0004\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.168843,\"Longitude\":-73.364452},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":50,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"0005\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.170393,\"Longitude\":-73.36316},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":50,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"0006\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":42.177239,\"Longitude\":-73.35206},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":50,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0}]}";
        static string latLonDeliveryRequest = "{\"RoutingService\":0,\"IsNeedMatchCode\":false,\"CurrentTime\":\"0001-01-01T00:00:00Z\",\"DispatchMode\":0,\"MinimumOptimization\":1,\"DistanceUnit\":1,\"Vehicles\":[{\"Name\":\"V1\",\"Email\":null,\"Group\":null,\"Speed\":0,\"MaxStops\":0,\"MaxWeight\":0,\"MaxSkids\":0,\"MaxVolume\":0,\"MaxMinutes\":0,\"OnTheRoad\":false,\"Tin\":\"0001-01-01T00:00:00Z\",\"Tout\":\"0001-01-01T00:00:00Z\",\"StartLocation\":{\"MatchCode\":0,\"Name\":null,\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":51.4429,\"Longitude\":5.4618},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},\"FinishLocation\":{\"MatchCode\":0,\"Name\":null,\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":51.4444,\"Longitude\":5.4776},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0}}],\"Locations\":[{\"MatchCode\":0,\"Name\":\"O11683\",\"Delivery\":\"B11683\",\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":51.44289,\"Longitude\":5.46119},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"B11683\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":51.486,\"Longitude\":5.4373},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":3,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"O11684\",\"Delivery\":\"B11688\",\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":51.44289,\"Longitude\":5.46119},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":0,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0},{\"MatchCode\":0,\"Name\":\"B11688\",\"Delivery\":null,\"Vehicle\":null,\"Description\":null,\"Phone\":null,\"LatLong\":{\"Latitude\":51.486,\"Longitude\":5.4373},\"Address\":null,\"Priority\":0,\"Wait\":0,\"Volume\":0,\"Weight\":0,\"Skids\":0,\"TimeConstraintArrival\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture\":\"0001-01-01T00:00:00Z\",\"TimeConstraintArrival2\":\"0001-01-01T00:00:00Z\",\"TimeConstraintDeparture2\":\"0001-01-01T00:00:00Z\",\"LocationType\":3,\"CanArriveEarly\":true,\"Distance\":0,\"Time\":0}]}";

        static void Main(string[] args)
        {
            //Login to get a key.
            string key = Login();

            if (key == null)
                return;

            //You can use the same key to make multiple requests.
            Dispatch(key, latLonRequest);
            Dispatch(key, addressRequest);
            Dispatch(key, midwayRequest);
            Dispatch(key, latLonDeliveryRequest);

        }

        static string Login()
        {
            //A data to send.
            string postData = "{\"UserName\":\"" + userName + "\",\"Password\":\"" + password + "\"}";

            //Create a variable for response.
            string response = null;
            try
            {
                //Make a request.
                response = CallService(loginUrl, postData);
            }
            catch (Exception ex)
            {
                //Show exception.
                Console.WriteLine(ex.ToString());
                return null;
            }

            Console.WriteLine("Login:");
            Console.WriteLine(response);

            //Parse result.
            JavaScriptSerializer json = new JavaScriptSerializer();
            Dictionary<string, object> data = json.Deserialize<Dictionary<string, object>>(response);

            //Check status
            if ((int)data["Status"] == 1)
            {
                string key = (string)data["Key"];
                return key;
            }
            else
            {
                Console.WriteLine("Press any key to continue...");
                Console.ReadKey();
            }
            return null;
        }

        static void Dispatch(string key, string postData)
        {
            string response = null;

            try
            {
                //Make a request.
                response = CallService(dispatchUrl + "/" + key, postData);
            }
            catch (Exception ex)
            {
                //Show exception.
                Console.WriteLine(ex.ToString());
                return;
            }
            Console.WriteLine("Dispatch:");
            Console.WriteLine(response);
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();

        }

        /// <summary>
        /// Sends data to specified URL as POST request and returns response.
        /// </summary>
        /// <param name="url">Request Url</param>
        /// <param name="postData">A data to send.</param>
        /// <returns>Returns a response as a System.String.</returns>
        static string CallService(string url, string postData)
        {
            HttpWebRequest httpWReq = (HttpWebRequest)WebRequest.Create(url);

            byte[] data = System.Text.Encoding.UTF8.GetBytes(postData);

            httpWReq.Timeout = 1000 * 60 * 30;//30 minutes
            httpWReq.Method = "POST";
            httpWReq.ContentType = "text/json; charset=utf-8";
            httpWReq.ContentLength = data.Length;

            using (Stream stream = httpWReq.GetRequestStream())
            {
                stream.Write(data, 0, data.Length);
            }

            HttpWebResponse response = (HttpWebResponse)httpWReq.GetResponse();

            string responseString = new StreamReader(response.GetResponseStream()).ReadToEnd();

            return responseString;
        }
    }
}
