﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Web.Script.Serialization;

namespace TrackService.Samples.Json.Geocode
{
    class Program
    {
        static string loginUrl = "http://trackservice.trackroad.com/rest/login";
        static string geocodeUrl = "http://trackservice.trackroad.com/rest/geocode";

        static string userName = "your_user_name";
        static string password = "your_password";

        static void Main(string[] args)
        {
            //Login to get a key.
            string key = Login();

            if (key == null)
                return;

            //Make a request.
            Geocode(key);

            //You can use the same key to make multiple requests.
            //Geocode(key);
            //Geocode(key);
        }

        static string Login()
        {
            //A data to send.
            string postData = "{\"UserName\":\"" + userName + "\",\"Password\":\"" + password + "\"}";

            //Create a variable for response.
            string response = null;
            try
            {
                //Make a request.
                response = CallService(loginUrl, postData);
            }
            catch (Exception ex)
            {
                //Show exception.
                Console.WriteLine(ex.ToString());
                return null;
            }

            Console.WriteLine("Login:");
            Console.WriteLine(response);

            //Parse result.
            JavaScriptSerializer json = new JavaScriptSerializer();
            Dictionary<string, object> data = json.Deserialize<Dictionary<string, object>>(response);

            //Check status
            if ((int)data["Status"] == 1)
            {
                string key = (string)data["Key"];
                return key;
            }
            else
            {
                Console.WriteLine("Press any key to continue...");
                Console.ReadKey();
            }
            return null;
        }

        static void Geocode(string key)
        {
            //A data to send.
            string postData = "{\"IsNeedMatchCode\":false,Addresses:[{\"Street\":\"6718 Whittier Ave\",\"City\":\"McLean\",\"State\":\"VA\",\"PostalCode\":\"22102\",\"Country\":\"US\"},{\"Street\":\"1450 Old Chain Bridge Road\",\"City\":\"McLean\",\"State\":\"МФ\",\"PostalCode\":\"22101\",\"Country\":\"US\"}]}";
            string response = null;

            try
            {
                //Make a request.
                response = CallService(geocodeUrl + "/" + key, postData);
            }
            catch (Exception ex)
            {
                //Show exception.
                Console.WriteLine(ex.ToString());
                Console.WriteLine("Press any key to continue...");
                Console.ReadKey();
                return;
            }
            Console.WriteLine("Geocode:");
            Console.WriteLine(response);
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        /// <summary>
        /// Sends data to specified URL as POST request and returns response.
        /// </summary>
        /// <param name="url">Request Url</param>
        /// <param name="postData">A data to send.</param>
        /// <returns>Returns a response as a System.String.</returns>
        static string CallService(string url, string postData)
        {
            HttpWebRequest httpWReq = (HttpWebRequest)WebRequest.Create(url);

            byte[] data = System.Text.Encoding.UTF8.GetBytes(postData);

            httpWReq.Method = "POST";
            httpWReq.ContentType = "text/json; charset=utf-8";
            httpWReq.ContentLength = data.Length;

            using (Stream stream = httpWReq.GetRequestStream())
            {
                stream.Write(data, 0, data.Length);
            }

            HttpWebResponse response = (HttpWebResponse)httpWReq.GetResponse();

            string responseString = new StreamReader(response.GetResponseStream()).ReadToEnd();

            return responseString;
        }
    }
}
