﻿using System;
using System.IO;
using System.Net;

namespace TrackService.Samples.Json.Login
{
    class Program
    {
        static string loginUrl = "http://trackservice.trackroad.com/rest/login";

        static string userName = "your_user_name";
        static string password = "your_password";

        static void Main(string[] args)
        {
            Login();
        }

        static void Login()
        {
            //A data to send.
            string postData = "{\"UserName\":\"" + userName + "\",\"Password\":\"" + password + "\"}";

            //Create a variable for response.
            string response = null;
            try
            {
                //Make a request.
                response = CallService(loginUrl, postData);
            }
            catch (Exception ex)
            {
                //Show exception.
                Console.WriteLine(ex.ToString());
                return;
            }

            Console.WriteLine(response);

            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        /// <summary>
        /// Sends data to specified URL as POST request and returns response.
        /// </summary>
        /// <param name="url">Request Url</param>
        /// <param name="postData">A data to send.</param>
        /// <returns>Returns a response as a System.String.</returns>
        static string CallService(string url, string postData)
        {
            HttpWebRequest httpWReq = (HttpWebRequest)WebRequest.Create(url);

            byte[] data = System.Text.Encoding.UTF8.GetBytes(postData);

            httpWReq.Method = "POST";
            httpWReq.ContentType = "text/json; charset=utf-8";
            httpWReq.ContentLength = data.Length;

            using (Stream stream = httpWReq.GetRequestStream())
            {
                stream.Write(data, 0, data.Length);
            }

            HttpWebResponse response = (HttpWebResponse)httpWReq.GetResponse();

            string responseString = new StreamReader(response.GetResponseStream()).ReadToEnd();

            return responseString;
        }
    }
}
